package com.usky.service.Impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.usky.entity.Sp_Iw2017;

import com.usky.service.NBService;
import com.usky.service.SendWXService;
import com.usky.utils.HttpClientUtilWX;
import com.usky.utils.HttpClientUtils;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.apache.log4j.Logger;
import org.hibernate.Query;
import org.hibernate.SQLQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Author zhangzilong
 * @Description //TODO
 * @Date $ $
 * @Param $
 * @return $
 */
@Service
@Transactional
public class NBServiceImpl extends BaseServieImpl implements NBService {
    private static final Logger LOGGER = Logger.getLogger(NBServiceImpl.class);
    @Autowired
    private SendWXService sendWXService;

    @Override
    public void saveCover(String s) {
//        String a = "a";
//        String sql = "INSERT INTO `" + a + "` VALUES (null,'" + s + "');";
//        SQLQuery qry = getSession().createSQLQuery(sql);
//        int i = qry.executeUpdate();


        JSONObject jsonObject = JSON.parseObject(s);
        System.out.println("jsonObject = " + jsonObject);

        //总数据
        JSONObject service = jsonObject.getJSONObject("service");
        //设备唯一编码
        String deviceId = String.valueOf(jsonObject.get("deviceId"));
        //数据体
        JSONObject data = service.getJSONObject("data");
        //设备编号
        Object ime = data.get("imei");

        String imei = String.valueOf(ime);

        String serviceId = String.valueOf(service.get("serviceId"));
        //设备名   建表
        String tab = "sp_iw" + imei;
        String sql1 = "CREATE TABLE IF NOT EXISTS `" + tab + "` (`id` int(25) unsigned NOT NULL AUTO_INCREMENT,`device_id` varchar(50) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '设备编号',`iot_id` varchar(50) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '设备唯一编码',`isRetrans` varchar(11) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '是否重发。0：否。1：是。',`angleSensorStatus` varchar(11) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '角度传感器状态。0：正常。1：异常',`tempSensorStatus` varchar(11) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '湿度传感器状态。0：正常。1：异常',`isRecover` varchar(11) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '是否恢复包。0：否。1：是。',`openStatus` varchar(11) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '井盖打开状态。0：正常。1：异常',`angle` varchar(11) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '倾斜角度',`rssi` varchar(11) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '信号强度',`voltage` varchar(11) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '当前电压值',`temp` varchar(11) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '温度值',`hum` varchar(11) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '湿度值',`rsrp` varchar(5) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '参考信号接收功率',`snr` varchar(5) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '信噪比',`service` text COLLATE utf8mb4_unicode_ci COMMENT '总数据',`addtime` datetime DEFAULT NULL COMMENT '数据包解析时间',`notifytype` varchar(11) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '消息类型。0：心跳。1：打开告警。4：打开恢复。5：其他',`serviceId` varchar(25) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '数据类型id',`parConfigStatus` varchar(25) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '参数配置状态',`payload` varchar(25) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '参数载荷',PRIMARY KEY (`id`)) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;";
        SQLQuery qry1 = this.getSession().createSQLQuery(sql1);
        int i1 = qry1.executeUpdate();
        //角度传感器状态
        String angleSensorStatus = String.valueOf(data.get("angleSensorStatus"));
        //  湿度传感器状态
        String tempSensorStatus = String.valueOf(data.get("tempSensorStatus"));
        //  是否恢复包
        String isRecover = String.valueOf(data.get("isRecover"));
        // 井盖打开状态
        String openStatus = String.valueOf(data.get("openStatus"));
        //  倾斜角度
        String angle = String.valueOf(data.get("angle"));
        //  信号强度
        String rssi = String.valueOf(data.get("rssi"));
        // 当前电压值
        String voltage1 = String.valueOf(data.get("voltage"));
//        Number num = Float.parseFloat(voltage1) * 20;
//        int vo = num.intValue();
        double vo = Double.parseDouble(voltage1);
        String voltage = "0";

        if (vo <= 3.0) {
            voltage = "0";
        } else if (vo == 3.1) {
            voltage = "10";
        } else if (vo == 3.2) {
            voltage = "20";
        } else if (vo == 3.3) {
            voltage = "40";
        } else if (vo == 3.4) {
            voltage = "60";
        } else if (vo == 3.5) {
            voltage = "80";
        } else if (vo >= 3.6) {
            voltage = "100";
        }


        //   温度值
        String temp = String.valueOf(data.get("temp"));
        //  湿度值
        String hum = String.valueOf(data.get("hum"));
        //  信噪比
        String snr = String.valueOf(data.get("snr"));
        //  参考信号接收功率
        String rsrp = String.valueOf(data.get("rsrp"));
        //   数据包解析时间
        String addtime = String.valueOf(data.get("eventTime"));
        //  消息类型
        String notifytype = String.valueOf(data.get("dataType"));

        if ("心跳".equals(notifytype)) {
            notifytype = "0";
        } else if ("打开告警".equals(notifytype)) {
            notifytype = "1";
        } else if ("打开恢复".equals(notifytype)) {
            notifytype = "4";
        } else {
            notifytype = "5";
        }

        //地址  data5
        String data5 = "";
        //开关状态
        if ("异常".equals(openStatus)) {
            openStatus = "1";
        } else {
            openStatus = "0";
        }
        //恢复包
        if ("否".equals(isRecover)) {
            isRecover = "0";
        } else {
            isRecover = "1";
        }
        //角度传感器状态
        if ("异常".equals(angleSensorStatus)) {
            angleSensorStatus = "1";
        } else {
            angleSensorStatus = "0";
        }
        //温湿度传感器状态

        if ("异常".equals(tempSensorStatus)) {
            tempSensorStatus = "1";
        } else {
            tempSensorStatus = "0";
        }
        //是否重发
        String isRetrans = "";
        if ("异常".equals(isRetrans)) {
            isRetrans = "1";
        } else {
            isRetrans = "0";
        }


        //详情
        JSONObject o = new JSONObject();
        o.put("openStatus", openStatus);
        o.put("isRecover", isRecover);
        o.put("angleSensorStatus", angleSensorStatus);
        o.put("tempSensorStatus", tempSensorStatus);
        o.put("isRetrans", isRetrans);
        o.put("rssi", rssi);
        o.put("voltage", voltage);
        o.put("temp", temp);
        o.put("hum", hum);
        o.put("angle", angle);
        o.put("snr", snr);
        o.put("rsrp", rsrp);
        String data3 = o.toString();
        System.out.println("data3 = " + data3);
        Sp_Iw2017 sp_iw2017 = new Sp_Iw2017();


        //todo    修改设备在线状态

        LOGGER.info("=========================井盖在线的=========");


        //多数据
        if ("ManholeData".equals(serviceId)) {
            //保存到设备表
            String sql2 = "INSERT INTO `" + tab + "` VALUES (null, '" + imei + "', '" + deviceId + "', '" + isRetrans + "','" + angleSensorStatus + "', '" + tempSensorStatus + "', '" + isRecover + "', '" + openStatus + "', '" + angle + "', '" + rssi + "', '" + voltage + "', '" + temp + "', '" + hum + "', '" + rsrp + "', '" + snr + "', '" + s + "', '" + addtime + "', '" + notifytype + "','" + serviceId + "',null,null);";
            SQLQuery qry2 = getSession().createSQLQuery(sql2);
            int i2 = qry2.executeUpdate();

            //根据值来确定当前状态是否可用hum
            // double value = Double.valueOf(temp.toString());
            double value1 = Double.valueOf(hum.toString());
            if (value1 == 0) {
                tempSensorStatus = "0";
            }
            //告警数据"4".equals(notifytype)
            if ("4".equals(notifytype)) {
                LOGGER.info("********************************告警数据上传告警表sp_iw2017*");
                String a = "";
                //打开恢复
                sp_iw2017.setDevice_code(imei);
                sp_iw2017.setStatus(openStatus);
                sp_iw2017.setRssi(rssi);
                sp_iw2017.setIsRecover(isRecover);
                sp_iw2017.setVoltage(voltage);
                sp_iw2017.setTemp(temp);
                sp_iw2017.setHum(hum);
                sp_iw2017.setData1(notifytype);
                sp_iw2017.setAngle(angle);
                sp_iw2017.setAngleSensorStatus(angleSensorStatus);
                sp_iw2017.setTempSensorStatus(tempSensorStatus);
                sp_iw2017.setIsRetrans(isRetrans);
                sp_iw2017.setSnr(snr);
                sp_iw2017.setRsrp(rsrp);
                sp_iw2017.setData3(data3);
                sp_iw2017.setData5(data5);
                sp_iw2017.setClnr("恢复");
                //恢復   已经处理
                sp_iw2017.setClr("admin");
                sp_iw2017.setClzt(1);
                Date date = new Date();
                SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd  HH:mm:ss");
                sp_iw2017.setClsj(df.format(new Date()));
                int i = (int) getSession().save(sp_iw2017);
                String id = String.valueOf(i);
                //上传微信
                String time = df.format(new Date());
                System.out.println("time = " + time);
                String evtname = "JG01";
                //this.CoversendWX(imei,id,time,evtname);
                String deviceStatus = "54";
                sendWXService.CoversendWX(imei, id, time, evtname, deviceStatus);
            } else if ("0".equals(notifytype)) {
                //心跳数据
                SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd  HH:mm:ss");
                String time = df.format(new Date());
                String deviceStatus = "0";
                String s1 = String.valueOf(vo);
                sendWXService.CoversendWX(imei, s1, time, rssi, deviceStatus);


            } else if ("1".equals(notifytype)) {
                LOGGER.info("********************************告警数据上传告警表sp_iw2017* ");

                //存2017  告警
                sp_iw2017.setDevice_code(imei);
                sp_iw2017.setStatus(openStatus);
                sp_iw2017.setRssi(rssi);
                sp_iw2017.setIsRecover(isRecover);
                sp_iw2017.setVoltage(voltage);
                sp_iw2017.setTemp(temp);
                sp_iw2017.setHum(hum);
                sp_iw2017.setData1(notifytype);
                sp_iw2017.setAngle(angle);
                sp_iw2017.setClzt(0);
                sp_iw2017.setAngleSensorStatus(angleSensorStatus);
                sp_iw2017.setTempSensorStatus(tempSensorStatus);
                sp_iw2017.setIsRetrans(isRetrans);
                sp_iw2017.setSnr(snr);
                sp_iw2017.setRsrp(rsrp);
                sp_iw2017.setData3(data3);
                sp_iw2017.setData5(data5);
                int i = (int) getSession().save(sp_iw2017);
                String id = String.valueOf(i);
                //上传微信
                // String id = sp_iw2017.getId().toString();
                System.out.println("id 1= " + id);
                SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd  HH:mm:ss");
                String time = df.format(new Date());
                System.out.println("time 1= " + time);
                String evtname = "JG02";
                // this.CoversendWX(imei,id,time,evtname);
                String deviceStatus = "53";
                sendWXService.CoversendWX(imei, id, time, evtname, deviceStatus);

            } else if ("1".equals(angleSensorStatus)) {
                LOGGER.info("********************************告警数据上传告警表sp_iw2017*");

                //存2017  传感器
                sp_iw2017.setDevice_code(imei);
                sp_iw2017.setStatus(openStatus);
                sp_iw2017.setRssi(rssi);
                sp_iw2017.setIsRecover(isRecover);
                sp_iw2017.setVoltage(voltage);
                sp_iw2017.setTemp(temp);
                sp_iw2017.setHum(hum);
                sp_iw2017.setData1(notifytype);
                sp_iw2017.setClzt(0);
                sp_iw2017.setAngle(angle);
                sp_iw2017.setAngleSensorStatus(angleSensorStatus);
                sp_iw2017.setTempSensorStatus(tempSensorStatus);
                sp_iw2017.setIsRetrans(isRetrans);
                sp_iw2017.setSnr(snr);
                sp_iw2017.setRsrp(rsrp);
                sp_iw2017.setData3(data3);
                sp_iw2017.setData5(data5);
                int i = (int) getSession().save(sp_iw2017);
                String id = String.valueOf(i);
                //上传微信
                SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd  HH:mm:ss");
                String time = df.format(new Date());
                String evtname = "JG03";
                //this.CoversendWX(imei,id,time,evtname);

                sendWXService.CoversendWX(imei, id, time, evtname, null);

            } else if ("1".equals(tempSensorStatus)) {
                LOGGER.info("********************************告警数据上传告警表sp_iw2017*");

                //存2017  告警
                sp_iw2017.setDevice_code(imei);
                sp_iw2017.setStatus(openStatus);
                sp_iw2017.setRssi(rssi);
                sp_iw2017.setIsRecover(isRecover);
                sp_iw2017.setVoltage(voltage);
                sp_iw2017.setTemp(temp);
                sp_iw2017.setHum(hum);
                sp_iw2017.setData1(notifytype);
                sp_iw2017.setAngle(angle);
                sp_iw2017.setAngleSensorStatus(angleSensorStatus);
                sp_iw2017.setTempSensorStatus(tempSensorStatus);
                sp_iw2017.setIsRetrans(isRetrans);
                sp_iw2017.setSnr(snr);
                sp_iw2017.setClzt(0);
                sp_iw2017.setRsrp(rsrp);
                sp_iw2017.setData3(data3);
                sp_iw2017.setData5(data5);
                int i = (int) getSession().save(sp_iw2017);
                String id = String.valueOf(i);
                //上传微信
                SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                String time = df.format(new Date());
                String evtname = "JG04";
                // this.CoversendWX(imei,id,time,evtname);
                sendWXService.CoversendWX(imei, id, time, evtname, null);

            }


        } else {
            //非告警数据
            String parConfigStatus = String.valueOf(data.get("parConfigStatus"));
            String payload = String.valueOf(data.get("payload"));

            //manholeconfig数据
            //保存到设备表
            String sql2 = "INSERT INTO `" + tab + "` VALUES (null, '" + imei + "', '" + deviceId + "',null, null,null, null, null,null, null, null, null,null,null,null, '" + s + "', '" + addtime + "', '" + notifytype + "','" + serviceId + "','" + parConfigStatus + "','" + payload + "');";
            SQLQuery qry2 = getSession().createSQLQuery(sql2);
            int i2 = qry2.executeUpdate();


        }


    }


    //发送微信
    @Override
    @Async
    public void CoversendWX(String imei, String id, String time, String evtname) {
        LOGGER.info("********************************告警数据开始上传微信*");

//        String hql = "from sp_iw2017 t where t.Id=" + id;
//        Query q = getSession().createQuery(hql);
//        List list2 = q.list();
        // String time1 = tRoleList.getTime();
        //System.out.println("time1 = " + time1);

        List<NameValuePair> nameValuePairsList = new ArrayList<>();
        StringBuffer sb = new StringBuffer();
        String sql = "SELECT company FROM sp_owner where owner_code='" + imei + "'";
        SQLQuery query = getSession().createSQLQuery(sql);
        List list = query.list();
        Object o = list.get(0);
        for (Object b : list) {
            System.out.println("b = " + b.toString());
        }
        String s = o.toString();
        String sql1 = "SELECT phone from sp_owner_phone  where data2 like'%6%' and owner_code='" + s + "'";
        Query query1 = getSession().createSQLQuery(sql1);
        List list1 = query1.list();
        for (Object b : list1) {
            System.out.println("b111 = " + b.toString());
        }
        if (list1 != null && list1.size() > 0) {
            for (Object sp : list1) {
                sb.append(sp);
                sb.append(",");
            }
        }
        BasicNameValuePair basicNameValuePair1 = new BasicNameValuePair("device_code", imei);
        // BasicNameValuePair basicNameValuePair2 = new BasicNameValuePair("phone",sb.toString());
        BasicNameValuePair basicNameValuePair2 = new BasicNameValuePair("phone", sb.toString());
        BasicNameValuePair basicNameValuePair3 = new BasicNameValuePair("insert_id", id);
        BasicNameValuePair basicNameValuePair4 = new BasicNameValuePair("time", time);
        BasicNameValuePair basicNameValuePair = new BasicNameValuePair("evt", evtname);
        nameValuePairsList.add(basicNameValuePair);
        nameValuePairsList.add(basicNameValuePair1);
        nameValuePairsList.add(basicNameValuePair2);
        nameValuePairsList.add(basicNameValuePair3);
        nameValuePairsList.add(basicNameValuePair4);

        String url = "https://iot.usky.cn/jdxf/wxapp2.php/Home/ManholeCoverwarn/message_manhole_cover";
        HttpClientUtilWX.doFromPost(url, null, nameValuePairsList);
        LOGGER.info("********************************告警数据上传微信完成*");


        //发送到c程序
        JSONObject js = new JSONObject();
        js.put("SubType", "128");
        js.put("DeviceId", imei);
        js.put("InsertId", id);
        js.put("Confirmed", "false");
        LOGGER.info("********************************告警数据开始上传C程序完成*");
        HttpClientUtils.doPostJson("http://47.98.201.187:55335/report", js.toJSONString());
        LOGGER.info("********************************告警数据上传C程序完成*");

    }

    @Override
    public String getStr(HttpServletRequest request) throws IOException {
        //接收数据
        BufferedReader br = null;
        br = new BufferedReader(new InputStreamReader(request.getInputStream()));

        String line1 = null;
        StringBuilder s = new StringBuilder();
        while ((line1 = br.readLine()) != null) {
            s.append(line1);

        }
        return s.toString();
    }


}
