package com.usky.utils;

import org.apache.log4j.Logger;
import org.springframework.beans.BeanUtils;

import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * @author laowo
 * @version v1.0
 * @date 2020/3/9 12:49
 * @description TODO
 **/

public class BeanHelp {
    private Logger logger = Logger.getLogger(BeanHelp.class);
    public static <T> T copyProperties(Object source, Class<T> target){
        try {
            T t = target.newInstance();
            BeanUtils.copyProperties(source, t);
            return t;
        } catch (Exception e) {
           /* logger.error("【数据转换】数据转换出错，目标对象{}构造函数异常", target.getName(), e);*/
            //logger.error();
            // throw new LyException(ExceptionEnum.DATA_TRANSFER_ERROR);
        }
        return null;
    }

    public static <T> List<T> copyWithCollection(List<?> sourceList, Class<T> target){
        try {
            return sourceList.stream().map(s -> copyProperties(s, target)).collect(Collectors.toList());
        } catch (Exception e) {
           // log.error("【数据转换】数据转换出错，目标对象{}构造函数异常", target.getName(), e);
            // throw new LyException(ExceptionEnum.DATA_TRANSFER_ERROR);
        }
        return null;
    }

    public static <T> Set<T> copyWithCollection(Set<?> sourceList, Class<T> target){
        try {
            return sourceList.stream().map(s -> copyProperties(s, target)).collect(Collectors.toSet());
        } catch (Exception e) {
           // log.error("【数据转换】数据转换出错，目标对象{}构造函数异常", target.getName(), e);
            // throw new LyException(ExceptionEnum.DATA_TRANSFER_ERROR);
        }
        return null;
    }


}
