package com.usky.utils;

import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpEntityEnclosingRequestBase;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @Author zhangzilong
 * @Description //TODO
 * @Date $ $
 * @Param $
 * @return $
 */
public class HttpClientUtilWX {

    //private static Logger logger = Logger.getLogger(HttpClientUtils.class);// 日志方便打印


    /**
     *  * post请求  * @param url  * @param authorValue  * @param json  * @return  
     */
    public static JSONObject doPost(String url, String authorValue, JSONObject json) {
        DefaultHttpClient client = new DefaultHttpClient();
        HttpPost post = new HttpPost(url);
        if (StringUtils.isNotEmpty(authorValue)) {
            post.setHeader("Authorization",authorValue);
        }
        JSONObject response = null;
        try {
            response = getJsonObject(json, client, post);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        return response;
    }

    public static JSONObject doPost(String url, String authorValue, Map map) {
        DefaultHttpClient client = new DefaultHttpClient();
        HttpPost post = new HttpPost(url);
        if (StringUtils.isNotEmpty(authorValue)) {
            post.setHeader("Authorization", authorValue);
        }
        JSONObject response = null;
        String result = "";
        try {
            StringEntity s = new StringEntity(map.toString());
            s.setContentEncoding("UTF-8");
            s.setContentType("application/json");// 发送json数据需要设置contentType
            post.setEntity(s);

            HttpResponse res = client.execute(post);
            HttpEntity entity = res.getEntity();
            result = EntityUtils.toString(entity);// 返回json格式：
            response = JSONObject.parseObject(result);
        } catch (Exception e) {
            //logger.error("doPost 请求解析失败 result = " + result);
            throw new RuntimeException(e);
        }
        return response;
    }

    private static JSONObject getJsonObject(JSONObject json, DefaultHttpClient client,
                                            HttpEntityEnclosingRequestBase base) throws IOException {
        JSONObject response;
        StringEntity s = new StringEntity(json.toString());
        s.setContentEncoding("UTF-8");
        s.setContentType("application/json");// 发送json数据需要设置contentType
        base.setEntity(s);

        HttpResponse res = client.execute(base);
        HttpEntity entity = res.getEntity();
        String result = EntityUtils.toString(entity);// 返回json格式：
        response = JSONObject.parseObject(result);
        return response;
    }

    /**
     *  * get 请求  * @param url  * @param authorValue  * @param para  * @return  
     */
    public static JSONObject doGet(String url, String authorValue, Map<String, String> para) {
        JSONObject response = null;
        String result = "";
        try {
            DefaultHttpClient client = new DefaultHttpClient();
            URIBuilder builder = new URIBuilder(url);
            Set<String> set = para.keySet();
            for (String key : set) {
                builder.setParameter(key, para.get(key));
            }
            HttpGet request = new HttpGet(builder.build());
            if (StringUtils.isNotEmpty(authorValue)) {
                request.setHeader("Authorization", authorValue);
            }
            request.setHeader("ContentTye", "application/json");
            RequestConfig requestConfig = RequestConfig.custom().setSocketTimeout(6000).setConnectTimeout(6000)
                    .setConnectionRequestTimeout(6000).build();
            request.setConfig(requestConfig);

            HttpResponse res = client.execute(request);
            // if(res.getStatusLine().getStatusCode() == HttpStatus.SC_OK){
            result = EntityUtils.toString(res.getEntity());// 返回json格式：
            response = JSONObject.parseObject(result);
            // }
        } catch (Exception e) {
            //logger.error("doGet 请求解析失败 result = " + result);
            throw new RuntimeException(e);
        }
        return response;
    }
    public static String doFromPost(String url, String authorValue, List list) {
        HttpClient client = new DefaultHttpClient(); //客户端对象
        HttpPost post = new HttpPost(url);             //请求对象
        HttpEntity entity = null;//模拟form进行表单提交
        try {
            entity = new UrlEncodedFormEntity(list);
            post.setEntity(entity);
            HttpResponse response = client.execute(post);//连接服务器
            if (response.getStatusLine().getStatusCode() == 200) {
                HttpEntity entit = response.getEntity();//获取内容
                return EntityUtils.toString(entit, "utf-8");
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (ClientProtocolException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return url;
    }


}
